=begin
#Polar Accesslink API

#Polar Accesslink API documentation

The version of the OpenAPI document: 3.78.0
Contact: b2bhelpdesk@polar.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.2.1

=end

require 'cgi'

module PolarAccesslinkApiGem
  class NightlyRechargeApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # List Nightly Recharges
    # List Nightly Recharge data of user for the last 28 days.
    # @param [Hash] opts the optional parameters
    # @return [Recharges]
    def list_nightly_recharge(opts = {})
      data, _status_code, _headers = list_nightly_recharge_with_http_info(opts)
      data
    end

    # List Nightly Recharges
    # List Nightly Recharge data of user for the last 28 days.
    # @param [Hash] opts the optional parameters
    # @return [Array<(Recharges, Integer, Hash)>] Recharges data, response status code and response headers
    def list_nightly_recharge_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: NightlyRechargeApi.list_nightly_recharge ...'
      end
      # resource path
      local_var_path = '/v3/users/nightly-recharge'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'Recharges'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['OAuth2']

      new_options = opts.merge(
        :operation => :"NightlyRechargeApi.list_nightly_recharge",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: NightlyRechargeApi#list_nightly_recharge\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get Nightly Recharge
    # Get Users Nightly Recharge data for given date.
    # @param date [String] Date of Nightly Recharge as ISO-8601 date string, example: \&quot;2020-01-01\&quot;
    # @param [Hash] opts the optional parameters
    # @return [NightlyRecharge]
    def v3_users_nightly_recharge_date_get(date, opts = {})
      data, _status_code, _headers = v3_users_nightly_recharge_date_get_with_http_info(date, opts)
      data
    end

    # Get Nightly Recharge
    # Get Users Nightly Recharge data for given date.
    # @param date [String] Date of Nightly Recharge as ISO-8601 date string, example: \&quot;2020-01-01\&quot;
    # @param [Hash] opts the optional parameters
    # @return [Array<(NightlyRecharge, Integer, Hash)>] NightlyRecharge data, response status code and response headers
    def v3_users_nightly_recharge_date_get_with_http_info(date, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: NightlyRechargeApi.v3_users_nightly_recharge_date_get ...'
      end
      # verify the required parameter 'date' is set
      if @api_client.config.client_side_validation && date.nil?
        fail ArgumentError, "Missing the required parameter 'date' when calling NightlyRechargeApi.v3_users_nightly_recharge_date_get"
      end
      # resource path
      local_var_path = '/v3/users/nightly-recharge/{date}'.sub('{' + 'date' + '}', CGI.escape(date.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'NightlyRecharge'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['OAuth2']

      new_options = opts.merge(
        :operation => :"NightlyRechargeApi.v3_users_nightly_recharge_date_get",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: NightlyRechargeApi#v3_users_nightly_recharge_date_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
